package com.huimv.guowei.admin.group.controller;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.group.entity.GroupDuckInfo;
import com.huimv.guowei.admin.group.entity.GroupThreshold;
import com.huimv.guowei.admin.group.service.IGroupDuckInfoService;
import com.huimv.guowei.admin.group.service.IGroupThresholdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 参数设置 前端控制器
 * </p>
 *
 * @author author
 * @since 2024-10-08
 */
@RestController
@RequestMapping("/group-threshold")
@CrossOrigin
public class GroupThresholdController {

    @Autowired
    private IGroupThresholdService thresholdService;
    @Autowired
    private IGroupDuckInfoService infoService;

    @RequestMapping("/list")
    public Result list(@RequestBody Map<String, String> paramsMap) {
        return thresholdService.list(paramsMap);
    }

    @RequestMapping("/addAndEdit")
    public Result addAndEdit(@RequestBody GroupThreshold groupThreshold) {
        return thresholdService.addAndEdit(groupThreshold);
    }

    @RequestMapping("/getResult")
    public Result getResult(@RequestBody Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        QueryWrapper<GroupThreshold> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId);
        GroupThreshold groupThreshold = thresholdService.getOne(queryWrapper);

        if (ObjectUtil.isNotEmpty(groupThreshold)) {
            Date updateTime = groupThreshold.getUpdateTime();
            Date date = new Date();
            long abs = Math.abs(date.getTime() - updateTime.getTime());
            long l = abs / (24 * 60 * 60 * 1000);
            if (l < 30) {
                return new Result(ResultCode.FAIL,false);

            } else {
                return new Result(ResultCode.SUCCESS,true);
            }
        } else {
            return new Result(ResultCode.SUCCESS,true);
        }
    }


    @RequestMapping("/getDuckCount")
    public Result getDuckCount(@RequestBody Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        QueryWrapper<GroupDuckInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).eq("is_leave", 0);
        queryWrapper.eq("unit_id", 9942);
        int count = infoService.count(queryWrapper);
        queryWrapper.clear();
        queryWrapper.eq("farm_id", farmId).eq("is_leave", 0);
        queryWrapper.eq("unit_id", 9943);
        int count1 = infoService.count(queryWrapper);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("five", count);
        jsonObject.put("six", count1);
        return new Result(ResultCode.SUCCESS, jsonObject);
    }
}
